#include "Light.h"

Light::Light ()
{
	ambient[0] = 0.0f;
	ambient[1] = 0.0f;
	ambient[2] = 0.0f;
	ambient[3] = 0.0f;

	diffuse[0] = 1.0f;
	diffuse[1] = 1.0f;
	diffuse[2] = 1.0f;
	diffuse[3] = 1.0f;

	specular[0] = 1.0f;
	specular[1] = 1.0f;
	specular[2] = 1.0f;
	specular[3] = 1.0f;

	position = new PositionPath ();
}

Light::~Light ()
{
	// nothing to do
}

void Light::SetAmbient (float red, float green, float blue, float alpha)
{
	ambient[0] = red;
	ambient[1] = green;
	ambient[2] = blue;
	ambient[3] = alpha;
}

void Light::SetDiffuse (float red, float green, float blue, float alpha)
{
	diffuse[0] = red;
	diffuse[1] = green;
	diffuse[2] = blue;
	diffuse[3] = alpha;
}

void Light::SetSpecular (float red, float green, float blue, float alpha)
{
	specular[0] = red;
	specular[1] = green;
	specular[2] = blue;
	specular[3] = alpha;
}

void Light::Bind (int id_)
{
	id = id_;
}

void Light::Apply (int time)
{
	Position pos;
	float pos_[4];

	pos = position->GetPosition (time);

	pos_[0] = pos.x;
	pos_[1] = pos.y;
	pos_[2] = pos.z;
	pos_[3] = 1.0f;

	glEnable (id);
	glLightfv (id, GL_AMBIENT, ambient);
	glLightfv (id, GL_DIFFUSE, diffuse);
	glLightfv (id, GL_SPECULAR, specular);
	glLightfv (id, GL_POSITION, pos_);
}


