#include "Demo.h"

#include "TestScene.h"
#include "TorusScene.h"
#include "GroupCullingScene.h"
#include "LandscapeScene.h"

/**
 * \mainpage Documentation 
 * This documentation explains all the classes used to build this small scene-graph like framework
 * that supports view frustum culling and objects with different levels of detail.
 */
int main (int argc, char * argv [])
{
	Demo *  demo;
	Scene * scene1;
	
	demo = new Demo ();

	//scene1 = new TestScene ();
	//demo->AddScene (scene1, 50000, 0);

	//scene1 = new GroupCullingScene ();
	//demo->AddScene (scene1, 50000, 0);

	scene1 = new TorusScene ();
	demo->AddScene (scene1, 50000, 0);

	scene1 = new LandscapeScene ();
	demo->AddScene (scene1, 100000, 5000);

	demo->Init (argc, argv);
	demo->Play ();

	delete demo;
}