#include "SimpleArrow.h"

SimpleArrow::SimpleArrow (double s)
{
	size = s;
}

SimpleArrow::~SimpleArrow ()
{
	// nothing to do
}

void SimpleArrow::Draw ()
{
	glBegin (GL_TRIANGLES);

		glColor4fv (color);

		glNormal3f (1.0f, 0.0f, 0.0f);
		glVertex3f (0.0f, 0.0f, 0.0f);
		glNormal3f (-0.707f, -0.707f, 0.0f);
		glVertex3f (-size, -size/2, 0.0f);
		glNormal3f (-0.707f, 0.707f, 0.0f);
		glVertex3f (-size, size/2, 0.0f);

		glColor4f (1.0f, 0.0f, 0.0f, 1.0f);

		glNormal3f (1.0f, 0.0f, 0.0f);
		glVertex3f (0.0f, 0.0f, 0.0f);
		glNormal3f (-0.707f, 0.0f, -0.707f);
		glVertex3f (-size, 0, -size/2);
		glNormal3f (-0.707f, 0.0f, 0.707f);
		glVertex3f (-size, 0, size/2);

		glColor4fv (color);

		glNormal3f (1.0f, 0.0f, 0.0f);
		glVertex3f (0.0f, 0.0f, 0.0f);
		glNormal3f (-0.707f, -0.707f, 0.0f);
		glVertex3f (-size, -size/2, -size/2);
		glNormal3f (-0.707f, 0.707f, 0.0f);
		glVertex3f (-size, size/2, size/2);

		glNormal3f (1.0f, 0.0f, 0.0f);
		glVertex3f (0.0f, 0.0f, 0.0f);
		glNormal3f (-0.707f, -0.707, 0.0f);
		glVertex3f (-size, -size/2, size/2);
		glNormal3f (-0.707f, 0.707, 0.0f);
		glVertex3f (-size, size/2, -size/2);
		
	glEnd ();
}

double SimpleArrow::GetBoundingRadius ()
{
	return size * 1.415;
}

BoundingBox SimpleArrow::GetBoundingBox ()
{
	BoundingBox result;

	result.xmin = -size;
	result.xmax = 0;
	result.ymin = -size / 2;
	result.ymax = size / 2;
	result.zmin = -size / 2;
	result.zmax = size / 2;

	return result;
}