#include "TestScene.h"
#include "TerminalObject.h"
#include "DLODObject.h"
#include "GroupObject.h"
#include "Teapot.h"
#include "Cube.h"
#include "Textures.h"
#include "Torus.h"

void TestScene::Init ()
{
	Light * light;

	RawObject * cube;
	GraphicalObject * terminal;

	// create 3 cubes that are textured with perlin noise
	cube = new TexturedCube (30.0f, Textures::GetId (T_PERLIN), true);
	terminal = new TerminalObject (cube);
	terminal->position->SetConstantPosition (0.0f, -35.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	AddObject (terminal);

	cube = new TexturedCube (30.0f, Textures::GetId (T_PERLIN2), true);
	terminal = new TerminalObject (cube);
	terminal->position->SetConstantPosition (.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	AddObject (terminal);

	cube = new TexturedCube (30.0f, Textures::GetId (T_PERLIN3), true);
	terminal = new TerminalObject (cube);
	terminal->position->SetConstantPosition (0.0f, 35.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	AddObject (terminal);


/*
	// Create teapot group
	GroupObject * teapot_cluster = new GroupObject ();

	// Create 6 teapots
	RawObject * raw_teapot_red = new Teapot (5.0f);
	GraphicalObject * teapot_red = new TerminalObject (raw_teapot_red);
	raw_teapot_red->SetColor (1.0f, 0.0f, 0.0f, 0.0f);
	teapot_red->position->StartPath (0, 20.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	teapot_red->position->SetDuration (20000);
	teapot_red->position->SetTransitionModes (PP_LINEAR, PP_LINEAR, PP_LINEAR, PP_LINEAR, PP_SINE, PP_COSINE);
	teapot_red->position->SetParameters (0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	teapot_red->position->CompletePath (20.0f, 0.0f, 0.0f, 0.0f, 3600.0f, 3600.0f);
	//teapot_red->position->SetConstantPosition (20.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	teapot_cluster->AddChild (teapot_red);

	RawObject * raw_teapot_yellow = new Teapot (5.0f);
	GraphicalObject * teapot_yellow = new TerminalObject (raw_teapot_yellow);
	raw_teapot_yellow->SetColor (1.0f, 1.0f, 0.0f, 0.0f);
	teapot_yellow->position->StartPath (0, -20.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	teapot_yellow->position->SetDuration (20000);
	teapot_yellow->position->SetGlobalTransition (PP_LINEAR, 0.0f);
	teapot_yellow->position->CompletePath (-20.0f, 0.0f, 0.0f, 0.0f, 0.0f, 3600.0f);
	//teapot_yellow->position->SetConstantPosition (-20.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	teapot_cluster->AddChild (teapot_yellow);

	teapot_yellow->position->PrintToConsole ();

	RawObject * raw_teapot_green = new Teapot (5.0f);
	GraphicalObject * teapot_green = new TerminalObject (raw_teapot_green);
	raw_teapot_green->SetColor (0.0f, 1.0f, 0.0f, 0.0f);
	teapot_green->position->StartPath (0, 0.0f, 20.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	teapot_green->position->SetDuration (20000);
	teapot_green->position->SetTransitionModes (PP_LINEAR, PP_LINEAR, PP_LINEAR, PP_SINE, PP_COSINE, PP_LINEAR);
	teapot_green->position->SetParameters (0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	teapot_green->position->CompletePath (0.0f, 20.0f, 0.0f, 3600.0f, 3600.0f, 0.0f);
	//teapot_green->position->SetConstantPosition (0.0f, 20.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	teapot_cluster->AddChild (teapot_green);

	RawObject * raw_teapot_lightblue = new Teapot (5.0f);
	GraphicalObject * teapot_lightblue = new TerminalObject (raw_teapot_lightblue);
	raw_teapot_lightblue->SetColor (0.0f, 1.0f, 1.0f, 0.0f);
	teapot_lightblue->position->StartPath (0, 0.0f, -20.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	teapot_lightblue->position->SetDuration (20000);
	teapot_lightblue->position->SetGlobalTransition (PP_LINEAR, 0.0f);
	teapot_lightblue->position->CompletePath (0.0f, -20.0f, 0.0f, 0.0f, 3600.0f, 0.0f);
	//teapot_lightblue->position->SetConstantPosition (0.0f, -20.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	teapot_cluster->AddChild (teapot_lightblue);

	RawObject * raw_teapot_darkblue = new Teapot (5.0f);
	GraphicalObject * teapot_darkblue = new TerminalObject (raw_teapot_darkblue);
	raw_teapot_darkblue->SetColor (0.0f, 0.0f, 1.0f, 0.0f);
	teapot_darkblue->position->StartPath (0, 0.0f, 0.0f, 20.0f, 0.0f, 0.0f, 0.0f);
	teapot_darkblue->position->SetDuration (20000);
	teapot_darkblue->position->SetTransitionModes (PP_LINEAR, PP_LINEAR, PP_LINEAR, PP_COSINE, PP_LINEAR, PP_SINE);
	teapot_darkblue->position->SetParameters (0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	teapot_darkblue->position->CompletePath (0.0f, 0.0f, 20.0f, 3600.0f, 0.0f, 3600.0f);
	//teapot_darkblue->position->SetConstantPosition (0.0f, 0.0f, 20.0f, 0.0f, 0.0f, 0.0f);
	teapot_cluster->AddChild (teapot_darkblue);

	RawObject * raw_teapot_pink = new Teapot (5.0f);
	GraphicalObject * teapot_pink = new TerminalObject (raw_teapot_pink);
	raw_teapot_pink->SetColor (1.0f, 0.0f, 1.0f, 0.0f);
	teapot_pink->position->StartPath (0, 0.0f, 0.0f, -20.0f, 0.0f, 0.0f, 0.0f);
	teapot_pink->position->SetDuration (20000);
	teapot_pink->position->SetGlobalTransition (PP_LINEAR, 0.0f);
	teapot_pink->position->CompletePath (0.0f, 0.0f, -20.0f, 3600.0f, 0.0f, 0.0f);
	//teapot_pink->position->SetConstantPosition (0.0f, 0.0f, -20.0f, 0.0f, 0.0f, 0.0f);
	teapot_cluster->AddChild (teapot_pink);

	this->AddObject (teapot_cluster);

	// Set the camera
	camera = new Camera ();
	camera->SetAttributes (45, 1.333, 1.0, 7000.0);

	camera->position->StartPath (0, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f, -180.0f);
	camera->position->SetDuration (6000);
	camera->position->SetGlobalTransition (PP_COSINE, 0.0f);
	camera->position->AddCheckpoint (50.0f, 0.0f, 20.0f, 0.0f, 0.0f, -180.0f);
	camera->position->SetDuration (6000);
	camera->position->SetGlobalTransition (PP_SINE, 0.0f);
	camera->position->AddCheckpoint (50.0f, 0.0f, 50.0f, 0.0f, 30.0f, -180.0f);
	camera->position->SetDuration (3000);
	camera->position->SetGlobalTransition (PP_LINEAR, 0.0f);
	camera->position->AddCheckpoint (60.0f, 60.0f, 60.0f, 0.0f, 30.0f, -135.0f);
	camera->position->SetDuration (6000);
	camera->position->SetGlobalTransition (PP_JUMP, 0.5f);
	camera->position->CompletePath (40.0f, 40.0f, 40.0f, 0.0f, 30.0f, -135.0f);
	camera->position->StartPath (0, 30.f, 30.0f, 30.0f, 0.0f, 30.0f, -135.0f);
	camera->position->SetDuration (6000);
	camera->position->SetGlobalTransition (PP_JUMP, 0.5f);
	camera->position->CompletePath (20.0f, 20.0f, 20.0f, 0.0f, 30.0f, -135.0f);
*/

	// Set the camera
	camera = new Camera ();
	camera->SetAttributes (45, 1.333, 1.0, 600.0);
	camera->position->SetConstantPosition (120.0f, 0.0f, 30.0f, 0.0f, 10.0f, 180.0f);


	// add one light at (0,0,0)
	light = new Light ();
	light->position->SetConstantPosition (20.0f, 20.0f, 20.0f, 0.0f, 0.0f, 0.0f);
	light->SetDiffuse (1.0f, 1.0f, 1.0f, 1.0f);
	light->SetSpecular (1.0f, 1.0f, 1.0f, 1.0f);
	light->SetAmbient (0.6f, 0.6f, 0.6f, 1.0f);
	AddLight (light);

}